/*****************************************************************************
*
* "pch.cpp"
***
** Purpose:	Generate precompiled header information
***     
*
*	(c)	Schneider electric 2017
*/

#define VDB_OVERRIDES_REMOTE_SOURCE

/* ==========================================================================
   = NOTE: Inclusion of oas_stddef.h ensures appropriate compiler warnings  =
   =       are promoted/enabled, and thus consistently applied during the   =
   =       compilation of each project source file; it MUST be included as  =
   =       the first entry in every precompiled header. Indeed, it SHOULD   =
   =       be included as the first entry in EVERY header, precompiled or   =
   =       otherwise, explicitly referenced or not.                         =
   ==========================================================================*/

// The following macro ensures that functions referenced within this file
// will be exported.
#define VDB_OVERRIDES_REMOTE_SOURCE

#include "oas_stddef.h"

#include <comdef.h>
#include "commonCMXTypes.h"
#include "cmx.h"
#include "fixedCMXTypenum.h"
#include "typenum.h"
#include "ius_vdb_overrides_GRT.h"
#include "ius_cpulib.h"
#include "ius_vdblib.h"
#include "RealTimeVPath.h"
#include "RealTimeDBError.h"
#include "RealTimeTable.h"
#include "RealTimeRecord.h"
#include "RealTimeField.h"


/*
 * this next include marks the end of the precompiled header definition
 */
#include "pch.h"
